%
% data loader
%
clear all;
base_dir1 = '..\';
addpath(genpath(base_dir1));
addpath([base_dir1,'src\']);
addpath([base_dir1,'src\iris\']);
addpath([base_dir1,'src\lesage\']);
base_dir  = '.\';
cd(base_dir);

% diary
delete('.\data_setup.out');
diary('.\data_setup.out');
disp(' ');

% data files  
disp(' ');
disp('data loader');
disp(' ');
disp(['current date: ' datestr(clock,31)]);
disp(['current directory: ', pwd]);

% get data from Mackowiak, Moench, Wiederholt (2009) JME
MMW_mainnew;

%
data_string = ['mmw09'];

% hicp aggregate
data.data_infl = data.data(:,1);
data.name_ser_infl = data.name_ser(1,1);

% subindices
data.data = data.data(:,2:end);
data.name_ser_group = data.name_ser_group(:,2:end);
data.name_ser = data.name_ser(:,2:end);

%
dum_print = 1;
if (dum_print ~= 0)
    disp(' ');
    disp('data');
    disp(data);
end

% make data balanced
dataus = [data.data_infl, data.data];
date_first_max = f_find_firstdate(size(dataus,2),dataus,data.dates,'max');
index_date_first = f_find_date(data.dates,date_first_max);
dum_print = 1;
if (dum_print ~= 0)
    disp(' ');
    disp([' first balanced observation: ',num2str(date_first_max(1,1)),'m',num2str(date_first_max(1,2))]);
end
data.data_fin = data.data(index_date_first:end,:);
data.data_infl = data.data_infl(index_date_first:end,:);
data.dates_fin = data.dates(index_date_first:end,:);

% collect groups
n_group_cat = size(data.name_ser_group,1);
for i=1:n_group_cat
    name_group = data.name_ser_group(i,:);
    disp(' ');
    disp(['group category ',num2str(i),' group names:']);
    name_group_uni = unique(name_group);
    disp([blanks(size(name_group_uni,2))',char(name_group_uni')]);
    for j=1:size(name_group_uni,2)
        index_group = strmatch(name_group_uni(:,j),name_group);
        data_raw = data.data_fin(:,index_group);
        data_std = [];
        for k=1:size(data_raw,2)
            data_std = [ data_std, (data_raw(:,k)-nanmean(data_raw(:,k)))/nanstd(data_raw(:,k)) ];
        end
        dum_plot = 0;
        if (dum_plot ~= 0)
            figure; newplot;
            plot(data_std);
            title(name_group_uni(:,j),'Interpreter','none');
        end
        dum_print = 0;
        if (dum_print ~= 0)
            disp(' ');
            disp(['name_group: ',name_group_uni{:,j}]);
            disp(data.name_ser(:,index_group));
        end
    end
end

% remove fields
data = rmfield(data, {'dates'});

dum_print = 1;
if (dum_print ~= 0)
    disp(' ');
    disp(['all series together: ']);
    disp([' no series  '  num2str(size(data.data_fin,2))]);
    disp([' no obs     '  num2str(size(data.data_fin,1))]);
    disp([' sample     '  num2str(data.dates_fin(1,1)),'m',num2str(data.dates_fin(1,2)), ' to ', ...
                          num2str(data.dates_fin(end,1)),'m',num2str(data.dates_fin(end,2)) ]);
    disp(' ');
    disp(['data']);
    disp(data);
end

%
% store
%
str = ([base_dir data_string '.mat']);
save(str,'data');

% diary
diary off;
disp(' '); 

return

