% function remove_outliers.m removes outliers from time series and replaces
% them with either the maximum or average observation over the remaining
% sample; outliers are defined as observations that lie outside a given
% percentile of all observations

function y_removed = remove_outliers(y_in,replacement);

y_removed = y_in;

out_up = find(y_in > 4*std(y_in));         
out_down = find(y_in < -4*std(y_in));         
out_indx = sort([out_down' out_up']);
num_out = length(out_indx);


% replace outliers
for o = 1:num_out,
    
    switch replacement
    
        case 'average'
        
            y_removed(out_indx(o)) = mean(y_in(notin([1:length(y_in)],out_indx)));
        
        case 'maxmin'
        
            if ~isempty(isin_ind(out_indx(o),out_up)), 
                y_removed(out_indx(o)) = max(y_in(notin([1:length(y_in)],out_indx)));
            else, 
                y_removed(out_indx(o)) = min(y_in(notin([1:length(y_in)],out_indx)));
            end;
        
    end; % end switch
        
end; % end for



