function Xq_out = f_time_aggregate(Xm_in,xq_type)
%
% time aggregation
%
if (any(isnan(Xm_in)) == 1)
    disp('error: NaN encountered!');
    return
end
if (all(all(isnan(Xm_in))) == 1)
    disp('error: series missing!');
    return
end
Tm = size(Xm_in,1);
if ( round((Tm-1)/3)-((Tm-1)/3) == 0 )
    disp('error: series is not of correct size!');
    return
end
Tq = Tm/3;

ndatatypes = 4;
A_types = zeros(Tq,Tm,ndatatypes); 
% I(0) stocks
for tq=1:Tq,
    A_types(tq,(1+(tq-1)*3+2),1) = 1;
end
% I(0) flows
for tq=1:Tq,
    A_types(tq,(1+(tq-1)*3):(1+(tq-1)*3+2),2) = 1/3;
end
% I(1) stocks
for tq=1:Tq,
    A_types(tq,(1+(tq-1)*3):(1+(tq-1)*3+2),3) = 1.0;
end
% I(1) flows
Aweights = [ 1/3, 2/3, 3/3, 2/3, 1/3];
A_types(1,1:3,4) = Aweights(3:5);
for tq=2:Tq,
    A_types(tq,(1+(tq-1)*3-2):(1+(tq-1)*3+2),4) = Aweights;
end

Xq_out = A_types(:,:,xq_type)*Xm_in;

return
