function dct = f_condkalfila(yt,lam,phi,psi,sigeps,sigeta,psilag,philag,nf) 

nvar=size(yt,2);
nobs=size(yt,1);
lamlag=1;
zdim = nf*max(philag,psilag+1);
zmat=zeros(zdim,nobs+1);
pmat=zeros(zdim,zdim,nobs+1);

%extract the relevant parameters
la = lam;
ps = psi;
ph = phi;

mu = zeros(nf,1);
state = ones(nobs+philag,1);

% restricting the vector of states, calculate ct 
st=mu(:,state)';
if philag>0
   st = f_lagtrans(st,philag,ph);
end
ct = [st(end-nobs+1:end,:) zeros(nobs,zdim-nf)];

% enter system matrices for state space model 
% yt = hmat*zt + e 
% zt = ct + fmat*zt-1 + u 
hmat = lam;
if psilag
for iind=1:psilag;
   hmat = [hmat -lam.*kron(psi(:,iind),ones(1,nf))];
end
end
if size(hmat,2)<zdim
    hmat=[hmat zeros(nvar,zdim-size(hmat,2))];
end
evar = diag(sigeps);
fmat = [zeros(nf,zdim);eye(zdim-nf,zdim)];
if philag>0;
   fmat(1:nf,1:nf*philag)=phi;
end;
uvar = [sigeta zeros(nf,zdim-nf);zeros(zdim-nf,zdim)];

% initialize Kalman Filter 
ztm=eye(nf);
for iind=1:philag
    ztm=ztm-phi(:,(iind-1)*nf+1:iind*nf);
end
zt=[mean(st,1)*inv(ztm)' zeros(1,zdim-nf)]';
pt = reshape(inv(eye(zdim^2)-kron(fmat,fmat))*uvar(:),zdim,zdim);

zmat=zeros(zdim,nobs+1); 
zpmat=zeros(zdim,nobs);
pmat=zeros(zdim,zdim,nobs+1);
ppmat=zeros(zdim,zdim,nobs);
zmat(:,1)=zt ; pmat(:,:,1)=pt;

%enter kalman filter 
for iind=1:nobs;
   %prediction
   zp=fmat*zt+ct(iind,:)';
   pp=fmat*pt*fmat'+uvar;
   %updating
   ft=hmat*pp*hmat'+evar;
   zt=zp+pp*hmat'*(inv(ft)*(yt(iind,:)'-hmat*zp));
   pt=pp-pp*hmat'*inv(ft)*hmat*pp;
   zmat(:,iind+1) = zt ; 
   pmat(:,:,iind+1)=pt; 
   zpmat(:,iind)=zp;
   ppmat(:,:,iind)=pp;
end;
% updating and generating dct 
selmat=eye(nf,zdim);
dct=randn(nobs,nf);
zt=zmat(:,nobs+1);
pt=pmat(:,:,nobs+1);
%dct(nobs,:)=zt'*selmat'+dct(nobs,:)*(selmat*chol(pt)*selmat');
dct(nobs,:)=zt'*selmat'+dct(nobs,:)*chol(selmat*pt*selmat');
%pu=pmat(:,:,nobs+1);
% zu=zmat(:,nobs+1);
for iind=nobs-1:-1:1;
   zt=zmat(:,iind+1);
   pt=pmat(:,:,iind+1);
   jt=inv(selmat*ppmat(:,:,iind+1)*selmat');
   zu=zt+pt*(selmat*fmat)'*jt*(dct(iind+1,:)'-selmat*zpmat(:,iind+1));
   pu=pt-pt*(selmat*fmat)'*jt*(selmat*fmat)*pt;
   dct(iind,:)= zu'*selmat' + dct(iind,:)*chol(selmat*pu*selmat');
 end;
