clear all
close all
rng default 
dbstop if error

prepare_pathsmodels

% generate folder and for results
folder='.\results\';
if not(exist(folder,'dir')==7)
    mkdir(folder);
end

% loop estimation
tstart=tic;
n_mod=size(modparam_mat,2);
parfor i=1:n_mod
    disp(' ');
    disp(['model ',num2str(i),' out of ',num2str(n_mod)]);
    modparam=modparam_mat(i).modparam;
    results=f_estimate_sparfac(data,modparam);
    % store results container
    nf=modparam.nf;prior=modparam.prior;s0=modparam.s0;utz=modparam.utz;
    res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                '_s',num2str(s0*100,'%03.0f'),'_utz',num2str(utz)];
    str=([folder,res_string]);
    f_save(str,results);
    results=[];
end

elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed estimation time ',num2str(elt),' hours']);

