clear all
close all

prepare_pathsmodels

%
% code until here exactly the same as in estimate_sparmod_variants
%

% loop evaluation and col change
tstart=tic;
n_mod=size(modparam_mat,2);
for i=1:n_mod
    disp(' ');
    disp(['model ',num2str(i),' out of ',num2str(n_mod)]);
    modparam=modparam_mat(i).modparam;
    % load estimation results
    nf=modparam.nf;prior=modparam.prior;s0=modparam.s0;utz=modparam.utz;
    res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                '_s',num2str(s0*100,'%03.0f'),'_utz',num2str(utz),'_final'];
    disp(res_string);
    folder_load='.\results_final\';
    
    res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                '_s',num2str(s0*100,'%03.0f'),'_utz',num2str(utz)];
    folder_load='.\results\';
    
    str=([folder_load,res_string]);
    load(str,'results');
    lamdraws=results.lamstarmc;
    fdraws=results.fstarmc;
    % evaluate draws: acf, geweke, etc.
    it_sel=1:size(lamdraws,3);
    folder_save='.\results_final_eval_draws\';
    rank_bekker_cond_cum=0;
    for j=it_sel
        [rank_bekker_cond,bekker_cond_fulfilled]=f_becker_cond(lamdraws(:,:,j));
        if bekker_cond_fulfilled==1;
            rank_bekker_cond_cum=rank_bekker_cond_cum+1;
        else 
%             squeeze(lamdraws(:,:,j))
%             pause
            disp(['  draw ',num2str(j),': bekker cond not fulfilled!']);
        end
    end
    disp(['  number of draws bekker cond is fulfilled: ',num2str(rank_bekker_cond_cum),' (pct: ',num2str(rank_bekker_cond_cum/length(it_sel)*100),'%)']);
    close all
    clear modparam
end

elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed time for final conv check ',num2str(elt),' hours']);

