function nofact = f_infobaing(x,ncmax,nindex);
%
% test for number of static factors according to Bai/Ng (2002)
%
dprint = 0;
[T,n] = size(x);

% V(kmax,F)
[X_estimate,Wk] = f_factor_estimate(x,ncmax);
ccresids = x-X_estimate;
vkfmax = sum(diag(cov(ccresids,1)))*(1/n);

% loop over number of static factors
nmethods = 7; % no. of information criteria
ncmat = zeros(ncmax,nmethods); % matrix for information criteria
ccbaingmat = zeros(T,ncmax);   % matrix for cc with various nc

for ncrun=1:ncmax
   
   % factors
   [X_estimate,Wk] = f_factor_estimate(x,ncrun);
   ccbaing = X_estimate;
   ccbaingmat(:,ncrun) = ccbaing(:,1);  % choose gdp cc for figures
   
   % V(k,F) and sigmahat
   ccresids = x-ccbaing;
   vkf = sum(diag(cov(ccresids,1)))*(1/n);
   sigma = vkfmax; % see Bai/Ng (2002), p.201
   
   % c2nt
   cnt = min(sqrt(n),sqrt(T));
   c2nt = cnt*cnt;
   
   % criteria
   pc1 = vkf+ncrun*sigma*((n+T)/(n*T))*log((n*T)/(n+T));
   pc2 = vkf+ncrun*sigma*((n+T)/(n*T))*log(c2nt);
   pc3 = vkf+ncrun*sigma*(log(c2nt)/c2nt);
   ic1 = log(vkf)+ncrun*((n+T)/(n*T))*log((n*T)/(n+T));
   ic2 = log(vkf)+ncrun*((n+T)/(n*T))*log(c2nt);
   ic3 = log(vkf)+ncrun*(log(c2nt)/c2nt);
   bic3 = vkf+ncrun*sigma*((n+T-ncrun)*log(n*T)/(n*T));
   ncmat(ncrun,:) = [pc1 pc2 pc3 ic1 ic2 ic3 bic3];
   
   % release information
   clear evalcc evalcc2 indexcc eveccc eveccc2 testreal wmat evecccbaing pc1 pc2 pc3 ic1 ic2 ic3; 
   
end   

% minimum
[ncmin ncindex] = min(ncmat); 
ncmat = [ncmat;ncindex];
r=1:ncmax; ncmat2 = [r';NaN]; 
ncmat = [ncmat2 ncmat];

% table
if dprint~=0
    disp('T,n'); disp([T n]); 
    disp('information criteria'); disp(' ');
    disp('lags pc1 pc2 pc3 ic1 ic2 ic3 bic3'); 
    disp(ncmat);
end

nofact = ncindex(nindex);

return
