clear all
close all
rng default 
dbstop if error

prepare_pathsdgpsmodels

tstart=tic;
for s0_index=1:length(s0_dgp_vec)
    s0_sim=s0_dgp_vec(s0_index);
    disp(' ');
    disp(['s0 ',num2str(s0_sim)]);
    disp(' ');
    for rep=1:n_rep
        rho0_sim=kron(ones(nf_sim,1),[30,s0_sim]); %rho0_1=precision, rho0_2=mean
        disp([' rep ',num2str(rep),' from ',num2str(n_rep)]);
        %
        % estimation with: different a) priors, b) factors
        for prior_index=1:n_prior
            prior=prior_est_vec(1,prior_index); % prior on factor loadings: 0: normal (hierarchical); 1: one-layer sparse; 2:two-layer sparse;
            for nf_index=1:nf_maxindex 
                nf=nf_vec(1,nf_index);
                disp(['  s0 ' num2str(s0_sim,'%4.2f') ', rep ' int2str(rep) ', prior ' int2str(prior) ', nf ' int2str(nf)]);
                setup_params_estimation
                modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0_sim, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
                % load estimation results
                res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                            '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz),'_rep',num2str(rep),'_final'];
                folder_load='.\results_final\';
                str=([folder_load,res_string]);
                load(str,'results');
                lamdraws=results.lamstarmc;
                fdraws=results.fstarmc;
                clear results
                % evaluate draws: acf, geweke, etc.
                it_sel=1:size(lamdraws,3);
                folder_save='.\results_final_eval_draws\';
                flag_longsmall='small'; % 'small' does not store all results
                results_eval_draws=f_eval_draws(modparam,lamdraws,fdraws,it_sel,folder_save,flag_longsmall,rep);
                close all
                clear results_eval_draws modparam
            end
        end
    end    
end

elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed time for conv check ',num2str(elt),' hours']);

