clear all
close all
rng default 
dbstop if error

prepare_pathsdgpsmodels

tstart=tic;
s0_dgp_vec=[0.5];
for s0_index=1:length(s0_dgp_vec)
    s0_sim=s0_dgp_vec(s0_index);
    disp(' ');
    disp(['s0 ',num2str(s0_sim)]);
    disp(' ');
    for rep=1:n_rep
        rho0_sim=kron(ones(nf_sim,1),[30,s0_sim]); %rho0_1=precision, rho0_2=mean
        disp([' rep ',num2str(rep),' from ',num2str(n_rep)]);
        %
        % load data based on s0
        dgp_spec=struct('N_sim',N_sim,'T_sim',T_sim,'T0_sim',T0_sim,'nf_sim',nf_sim, ...
            'philag_sim',philag_sim,'psilag_sim',psilag_sim,'rho0_sim',rho0_sim);
        load_str=['datasim_s',num2str(s0_sim*100,'%03.0f'),'_rep',num2str(rep)];
        loadname=['.\data\',load_str]';
        load(loadname,'datasim');
        xt=datasim.xt;
        fdraws_true=datasim.ftstar_true;
        lamdraws_true=datasim.lamspar_true;
        lamspar_index_true=datasim.lamspar_index_true;
        clear datasim
        % few stats from data
        index_true_sel=41:60; N_irrrel=length(index_true_sel);
        lamspar_index_true_sel=lamspar_index_true(index_true_sel,:); % select those columns to be evaluated
        variable_relevant_true_index=sum(lamspar_index_true_sel,2)>=1;
        no_variable_relevant_true=sum(variable_relevant_true_index,1);
        variable_irrelevant_true_index=sum(lamspar_index_true_sel,2)==0;
        no_variable_irrelevant_true=sum(variable_irrelevant_true_index,1);
        disp([' dgp sample: no relevant variables ',num2str(no_variable_relevant_true),', no irrelevant variables ',num2str(no_variable_irrelevant_true)]);
        n_overlap=sum(sum(lamspar_index_true,2)==2,1);
        disp([' relevant variables in each factor: ',num2str(sum(lamspar_index_true,1)),', overlaps: ',num2str(n_overlap)]);
        %
        % load estimation results with: different a) priors, b) factors
        for prior_index=1:n_prior
            prior=prior_est_vec(1,prior_index); % prior on factor loadings: 0: normal (hierarchical); 1: one-layer sparse; 2:two-layer sparse;
            for nf_index=1:nf_maxindex 
                nf=nf_vec(1,nf_index);
                disp(['  s0 ' num2str(s0_sim,'%4.2f') ', rep ' int2str(rep) ', prior ' int2str(prior) ', nf ' int2str(nf)]);
                setup_params_estimation
                modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0_sim, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
                % load estimation results
                % fig_spec_k2_prior0_s010_utz0_rep6_fdraws_corraftersignchange_own
                folder_load='.\results_final_eval_draws\';
                flag_corr_acf='acf';
                if strcmp(flag_corr_acf,'corr')
                    fig_string1=['fig_spec','_k',num2str(nf),'_prior',num2str(prior), ...
                                 '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz), ...
                                 '_rep',num2str(rep),'_fdraws_own.fig'];
                    fig_string2=['fig_spec','_k',num2str(nf),'_prior',num2str(prior), ...
                                 '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz), ...
                                 '_rep',num2str(rep),'_fdraws_cross.fig'];
                elseif strcmp(flag_corr_acf,'acf')
                    fig_string1=['fig_spec','_k',num2str(nf),'_prior',num2str(prior), ...
                                 '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz), ...
                                 '_rep',num2str(rep),'_acf_fdraws.fig'];
                    fig_string2=['fig_spec','_k',num2str(nf),'_prior',num2str(prior), ...
                                 '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz), ...
                                 '_rep',num2str(rep),'_acf_lamdraws.fig'];
                end
                wid_hei=[1/3,1/2];
                str=([folder_load,fig_string1]);openfig(str);set(gcf,'Units','normalized');
                str=([folder_load,fig_string2]);openfig(str);set(gcf,'Units','normalized');
                if prior_index==1; pos1=[0,0.5,wid_hei];  pos2=[0,0,wid_hei];  set(1,'OuterPosition',pos1);set(2,'OuterPosition',pos2);end
                if prior_index==2; pos1=[1/3,0.5,wid_hei];pos2=[1/3,0,wid_hei];set(3,'OuterPosition',pos1);set(4,'OuterPosition',pos2);end
                if prior_index==3; pos1=[2/3,0.5,wid_hei];pos2=[2/3,0,wid_hei];set(5,'OuterPosition',pos1);set(6,'OuterPosition',pos2);end
            end
        end
        pause
        
        close all
    end    
end


return
for s0_index=1:length(s0_dgp_vec)
    s0_sim=s0_dgp_vec(s0_index);
    disp(' ');
    disp(['s0 ',num2str(s0_sim)]);
    disp(' ');
    for rep=1:n_rep
        rho0_sim=kron(ones(nf_sim,1),[30,s0_sim]); %rho0_1=precision, rho0_2=mean
        disp([' rep ',num2str(rep),' from ',num2str(n_rep)]);
        %
        % estimation with: different a) priors, b) factors
        for prior_index=1:n_prior
            prior=prior_est_vec(1,prior_index); % prior on factor loadings: 0: normal (hierarchical); 1: one-layer sparse; 2:two-layer sparse;
            for nf_index=1:nf_maxindex 
                nf=nf_vec(1,nf_index);
                disp(['  s0 ' num2str(s0_sim,'%4.2f') ', rep ' int2str(rep) ', prior ' int2str(prior) ', nf ' int2str(nf)]);
                setup_params_estimation
                modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0_sim, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
                % load estimation results
                res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                            '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz),'_rep',num2str(rep),'_final'];
                folder_load='.\results_final\';
                str=([folder_load,res_string]);
                load(str,'results');
                lamdraws=results.lamstarmc;
                fdraws=results.fstarmc;
                clear results
                % evaluate draws: acf, geweke, etc.
                it_sel=1:size(lamdraws,3);
                folder_save='.\results_final_eval_draws\';
                flag_longsmall='small'; % 'small' does not store all results
                results_eval_draws=f_eval_draws(modparam,lamdraws,fdraws,it_sel,folder_save,flag_longsmall,rep);
                close all
                clear results_eval_draws modparam
            end
        end
    end    
end

elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed time for conv check ',num2str(elt),' hours']);

