clear all
close all
rng default 

prepare_pathsdgpsmodels
N=N_sim;
clev=0.95;

% generate folder and for results
folder_save='.\results_eval_relevance\'; % folder to store results
if not(exist(folder_save,'dir')==7)
    mkdir(folder_save);
end

% output matrices
rmse_matrix=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_relindgp_foundcorrectly_pval1s=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_relindgp_pval1s=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_irrelindgp_foundcorrectly_pval1s=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_irrelindgp_pval1s=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_relindgp_foundcorrectly_lamhpd=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_relindgp_lamhpd=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_irrelindgp_foundcorrectly_lamhpd=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_irrelindgp_lamhpd=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_relindgp_foundcorrectly_mhpdmah=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_relindgp_mhpdmah=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_irrelindgp_foundcorrectly_mhpdmah=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);
mat_no_irrelindgp_mhpdmah=nan(n_prior*nf_maxindex,size(s0_dgp_vec,2),n_rep);

load_flag='on';
if not(strcmp(load_flag,'on'))
    
% evaluation loop
tstart=tic;
for s0_index=1:length(s0_dgp_vec)
    s0_sim=s0_dgp_vec(s0_index);
    disp(' ');
    disp(['s0 ',num2str(s0_sim)]);
    disp(' ');
    for rep=1:n_rep
        rho0_sim=kron(ones(nf_sim,1),[30,s0_sim]); %rho0_1=precision, rho0_2=mean
        disp([' rep ',num2str(rep),' from ',num2str(n_rep)]);
        %
        % load data based on s0
        dgp_spec=struct('N_sim',N_sim,'T_sim',T_sim,'T0_sim',T0_sim,'nf_sim',nf_sim, ...
            'philag_sim',philag_sim,'psilag_sim',psilag_sim,'rho0_sim',rho0_sim);
        load_str=['datasim_s',num2str(s0_sim*100,'%03.0f'),'_rep',num2str(rep)];
        loadname=['.\data\',load_str]';
        load(loadname,'datasim');
        xt=datasim.xt;
        fdraws_true=datasim.ftstar_true;
        lamdraws_true=datasim.lamspar_true;
        lamspar_index_true=datasim.lamspar_index_true;
        clear datasim
        % few stats from data
        index_true_sel=41:60; N_irrrel=length(index_true_sel);
        lamspar_index_true_sel=lamspar_index_true(index_true_sel,:); % select those columns to be evaluated
        variable_relevant_true_index=sum(lamspar_index_true_sel,2)>=1;
        no_variable_relevant_true=sum(variable_relevant_true_index,1);
        variable_irrelevant_true_index=sum(lamspar_index_true_sel,2)==0;
        no_variable_irrelevant_true=sum(variable_irrelevant_true_index,1);
        disp([' dgp sample: no relevant variables ',num2str(no_variable_relevant_true),', no irrelevant variables ',num2str(no_variable_irrelevant_true)]);
        n_overlap=sum(sum(lamspar_index_true,2)==2,1);
        disp([' relevant variables in each factor: ',num2str(sum(lamspar_index_true,1)),', overlaps: ',num2str(n_overlap)]);
        %
        % load estimation results with: different a) priors, b) factors
        for prior_index=1:n_prior
            prior=prior_est_vec(1,prior_index); % prior on factor loadings: 0: normal (hierarchical); 1: one-layer sparse; 2:two-layer sparse;
            for nf_index=1:nf_maxindex 
                nf=nf_vec(1,nf_index);
                disp(['  s0 ' num2str(s0_sim,'%4.2f') ', rep ' int2str(rep) ', prior ' int2str(prior) ', nf ' int2str(nf)]);
                setup_params_estimation
                modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0_sim, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
                % load estimation results
                res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                            '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz),'_rep',num2str(rep),'_final'];
                folder_load='.\results_final\';
                str=([folder_load,res_string]);
                load(str,'results');
                lamdraws=results.lamstarmc;
                fdraws=results.fstarmc;
                clear results
                % pick draws
                itfinal=min(2000,size(lamdraws,3));
                lamdraws=lamdraws(:,:,end-itfinal+1:end);
                fdraws=fdraws(:,:,end-itfinal+1:end);
                %
                % evaluate mse of common component
                [mse_rep,rmse_rep]=f_mse_cc(lamdraws_true,fdraws_true,lamdraws,fdraws);
                rmse_matrix((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=rmse_rep;
                %
                % pval count posterior draws larger or smaller than zero (one-sided)
                lamstarmc=lamdraws;
                a=lamdraws;
                asmall=a<0.0; 
                alarge=a>0.0;
                slarge=sum(alarge,3);
                ssmall=sum(asmall,3);
                aa=max(slarge,ssmall); % choose largest, left or right, area as the region of inclusion
                pval1s=aa/size(lamstarmc,3); % compute one-sided prob 
                pval1s=pval1s(index_true_sel,:);
                pval1s_index_rel=find(sum(pval1s>clev,2));
                pval1s_index_irrel=setdiff(1:N_irrrel,pval1s_index_rel);
                pval1s_index_irrel=pval1s_index_irrel';
                index_relindgp_foundcorrectly=intersect(pval1s_index_rel,find(variable_relevant_true_index));
                no_relindgp_foundcorrectly=length(index_relindgp_foundcorrectly);
                index_irrelindgp_foundcorrectly=intersect(pval1s_index_irrel,find(variable_irrelevant_true_index));
                no_irrelindgp_foundcorrectly=length(index_irrelindgp_foundcorrectly);
                mat_no_relindgp_foundcorrectly_pval1s((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_relindgp_foundcorrectly;
                mat_no_relindgp_pval1s((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_relevant_true;
                mat_no_irrelindgp_foundcorrectly_pval1s((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_irrelindgp_foundcorrectly;
                mat_no_irrelindgp_pval1s((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_irrelevant_true;
                %
                % univariarte hpd
                lamhpd = nan(N,nf);
                for i=1:N
                    for j=1:nf
                        lamij = squeeze(lamstarmc(i,j,:));
                        ki = f_hpd(lamij,1-clev);
                        lamhpd(i,j) = (min(ki)>0.0||max(ki)<0.0); 
                    end
                end
                lamhpd=lamhpd(index_true_sel,:);
                lamhpd_index_rel=find(sum(lamhpd>0.0,2));
                lamhpd_index_irrel=setdiff(1:N_irrrel,lamhpd_index_rel);
                lamhpd_index_irrel=lamhpd_index_irrel';
                index_relindgp_foundcorrectly=intersect(lamhpd_index_rel,find(variable_relevant_true_index));
                no_relindgp_foundcorrectly=length(index_relindgp_foundcorrectly);
                index_irrelindgp_foundcorrectly=intersect(lamhpd_index_irrel,find(variable_irrelevant_true_index));
                no_irrelindgp_foundcorrectly=length(index_irrelindgp_foundcorrectly);
                mat_no_relindgp_foundcorrectly_lamhpd((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_relindgp_foundcorrectly;
                mat_no_relindgp_lamhpd((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_relevant_true;
                mat_no_irrelindgp_foundcorrectly_lamhpd((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_irrelindgp_foundcorrectly;
                mat_no_irrelindgp_lamhpd((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_irrelevant_true;
                %
                % excl_matrix95mhpdbesag, excl_matrix95mhpdmah: find how many of irrelevant variables are
                % labelled as relevant in estimation based on multivariate hpd
                disp_flag='off';fig_flag='off';
                vec_zero=zeros(1,nf);
                clev=0.95;
                method_str='mah';
                inclprob_besag_index=zeros(N,1);
                inclprob_mah_index=zeros(N,1);
                for i=1:N
                    if nf==1
                        lami=squeeze(lamstarmc(i,:,:));
                    else
                        lami=squeeze(lamstarmc(i,:,:))';
                    end
                    [mhpd_besag,pval_besag]=f_mhpd_besag(lami,clev,disp_flag,vec_zero);
                    ki_out=nan(nf,1);
                    for j=1:nf
                        ki=mhpd_besag(j,:);
                        ki_out(j,:)=(min(ki)>vec_zero(j)||max(ki)<vec_zero(j)); 
                    end
                    if sum(ki_out)>0
                        % lami is >0 in at least in one direction  (==nf in all directions)
                        inclprob_besag_index(i,1)=1;
                    end
                    [mhpd_mah,pval_mah]=f_mscb_euc(lami,clev,method_str,disp_flag,fig_flag,vec_zero);
                    ki_out=nan(nf,1);
                    for j=1:nf
                        ki=mhpd_mah(j,:);
                        ki_out(j,:)=(min(ki)>vec_zero(j)||max(ki)<vec_zero(j)); 
                    end
                    if sum(ki_out)>0
                        % lami is >0 in at least in one direction  (==nf in all directions)
                        inclprob_mah_index(i,1)=1;
                    end
                end
                inclprob_besag_index=inclprob_besag_index(index_true_sel,:);
                mhpdbesag_index_rel=find(inclprob_besag_index);
                mhpdbesag_index_irrel=setdiff(1:N_irrrel,mhpdbesag_index_rel);
                mhpdbesag_index_irrel=mhpdbesag_index_irrel';
                index_relindgp_foundcorrectly=intersect(mhpdbesag_index_rel,find(variable_relevant_true_index));
                no_relindgp_foundcorrectly=length(index_relindgp_foundcorrectly);
                index_irrelindgp_foundcorrectly=intersect(mhpdbesag_index_irrel,find(variable_irrelevant_true_index));
                no_irrelindgp_foundcorrectly=length(index_irrelindgp_foundcorrectly);
                mat_no_relindgp_foundcorrectly_mhpdbesag((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_relindgp_foundcorrectly;
                mat_no_relindgp_mhpdbesag((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_relevant_true;
                mat_no_irrelindgp_foundcorrectly_mhpdbesag((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_irrelindgp_foundcorrectly;
                mat_no_irrelindgp_mhpdbesag((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_irrelevant_true;
                %disp([' besag: no of correctly identified relevant variables ',num2str(no_relindgp_foundcorrectly),' from ',num2str(no_variable_relevant_true)]);
                %disp([' besag: no of correctly identified irrelevant variables ',num2str(no_irrelindgp_foundcorrectly),' from ',num2str(no_variable_irrelevant_true)]);
                inclprob_mah_index=inclprob_mah_index(index_true_sel,:);
                mhpdmah_index_rel=find(inclprob_mah_index);
                mhpdmah_index_irrel=setdiff(1:N_irrrel,mhpdmah_index_rel);
                mhpdmah_index_irrel=mhpdmah_index_irrel';
                index_relindgp_foundcorrectly=intersect(mhpdmah_index_rel,find(variable_relevant_true_index));
                no_relindgp_foundcorrectly=length(index_relindgp_foundcorrectly);
                index_irrelindgp_foundcorrectly=intersect(mhpdmah_index_irrel,find(variable_irrelevant_true_index));
                no_irrelindgp_foundcorrectly=length(index_irrelindgp_foundcorrectly);
                mat_no_relindgp_foundcorrectly_mhpdmah((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_relindgp_foundcorrectly;
                mat_no_relindgp_mhpdmah((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_relevant_true;
                mat_no_irrelindgp_foundcorrectly_mhpdmah((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_irrelindgp_foundcorrectly;
                mat_no_irrelindgp_mhpdmah((prior_index-1)*nf_maxindex+nf_index,find(s0_dgp_vec==s0_dgp_vec(s0_index)),rep)=no_variable_irrelevant_true;
            end
        end
    end    
end
elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed estimation time ',num2str(elt),' hours']);

% results struct
results.rmse_matrix=rmse_matrix;
method_str_vec={'pval1s','lamhpd','mhpdbesag','mhpdmah'};
for i=1:size(method_str_vec,2)
    method_str=method_str_vec{1,i};
    eval(['results.mat_no_relindgp_foundcorrectly_',method_str,'=','mat_no_relindgp_foundcorrectly_',method_str]);
    eval(['results.mat_no_relindgp_',method_str,'=','mat_no_relindgp_',method_str]);
    eval(['results.mat_no_irrelindgp_foundcorrectly_',method_str,'=','mat_no_irrelindgp_foundcorrectly_',method_str]);
    eval(['results.mat_no_irrelindgp_',method_str,'=','mat_no_irrelindgp_',method_str]);
end

% store results
savename = [folder_save,'results_relevance'];
save(savename,'results');

else
    
% load results
loadname = [folder_save,'results_relevance'];
load(loadname);

% index two-layer
index_ref = 3;
    
%
% mse, rmse
%
rmse = mean(results.rmse_matrix,3);
index_rest = setdiff(1:size(rmse,1),index_ref);
rmse_diff_mat = nan(size(index_rest,2),size(results.rmse_matrix,2),size(results.rmse_matrix,3));
rmse_sd = std(results.rmse_matrix,0,3);
ii = 1;
for index = index_rest
    rmse_diff_mat(ii,:,:) = results.rmse_matrix(index,:,:)-results.rmse_matrix(index_ref,:,:);
    ii = ii+1;
end
rmse_diff = median(rmse_diff_mat,3);
rmse_diff_mat_p = permute(rmse_diff_mat,[3 1 2]);
rmse_diff_mat_p2 = reshape(rmse_diff_mat_p,size(rmse_diff_mat,3),size(rmse_diff_mat,1)*size(rmse_diff_mat,2));
ki_mat = nan(size(rmse_diff_mat_p2,2),2);
for i=1:size(rmse_diff_mat_p2,2)
    ki = f_hpd(rmse_diff_mat_p2(:,i),1.0-clev);
    ki_mat(i,:) = ki;
end
rmse_diff_ki = [reshape(rmse_diff,size(rmse_diff_mat,1)*size(rmse_diff_mat,2),1),ki_mat]';
rmse_diff_all = reshape(rmse_diff_ki,size(rmse_diff_mat,1)*3,size(rmse_diff_mat,2));
rmse_diff_sd = std(rmse_diff_mat,0,3);
rmse_diff_lzero = mean(rmse_diff_mat>0.0,3)*100;

disp(' ');
disp('rmse mean over mc rep');
disp(rmse);
disp('rmse std over mc rep');
disp(rmse_sd);
disp('rmse normalized to one for two-layer prior');
rmse_tlp = rmse(index_ref,:);
rmse_reltlp=rmse./kron(ones(n_prior*nf_maxindex,1),rmse_tlp);
disp(rmse_reltlp);
disp('rmse diff median over mc rep');
disp(rmse_diff);
disp('rmse diff median over mc rep, 90% hpdi lower bound, upper bound');
disp(rmse_diff_all);
disp('pct of mc rep the rmse diff >0 (two-layer is better)');
disp(rmse_diff_lzero);

%
% identification of rel and irrel variables
%
method_str_vec={'lamhpd','mhpdbesag','mhpdmah'};
for i=1:size(method_str_vec,2)
    method_str=method_str_vec{1,i};
    eval(['mat_no_relindgp_foundcorrectly_',method_str,'=','results.mat_no_relindgp_foundcorrectly_',method_str,';']);
    eval(['mat_no_relindgp_',method_str,'=','results.mat_no_relindgp_',method_str,';']);
    eval(['mat_no_irrelindgp_foundcorrectly_',method_str,'=','results.mat_no_irrelindgp_foundcorrectly_',method_str,';']);
    eval(['mat_no_irrelindgp_',method_str,'=','results.mat_no_irrelindgp_',method_str,';']);
end
disp(' ');
for i=1:size(method_str_vec,2)
    method_str=method_str_vec{1,i};
    eval(['mat_no_relindgp_foundcorrectly','=','mat_no_relindgp_foundcorrectly_',method_str,';']);
    eval(['mat_no_relindgp','=','mat_no_relindgp_',method_str,';']);
    eval(['mat_no_irrelindgp_foundcorrectly','=','mat_no_irrelindgp_foundcorrectly_',method_str,';']);
    eval(['mat_no_irrelindgp','=','mat_no_irrelindgp_',method_str,';']);
    % rel
    mat_no_relindgp_foundcorrectly_sel=mat_no_relindgp_foundcorrectly; % if both are zero, we cannot compute ratio; to do so, we set both elements to one
    mat_no_relindgp_sel=mat_no_relindgp;                               
    mat_no_relindgp_foundcorrectly_sel(mat_no_relindgp_foundcorrectly==0 & mat_no_relindgp==0)=1.0;
    mat_no_relindgp_sel(mat_no_relindgp_foundcorrectly==0 & mat_no_relindgp==0)=1.0;
    flag_ratio='on';
    if strcmp(flag_ratio,'on')
        mat_no_relindgp_foundcorrectly_sel=mat_no_relindgp_foundcorrectly_sel./mat_no_relindgp_sel;
    end
    no_relindgp_foundcorrectly_mean=mean(mat_no_relindgp_foundcorrectly_sel,3);    
    eval(['mat_no_relindgp_foundcorrectly_sel_',method_str,'=','mat_no_relindgp_foundcorrectly_sel;']);
    eval(['no_relindgp_foundcorrectly_mean_',method_str,'=','no_relindgp_foundcorrectly_mean;']);
    % irrel
    mat_no_irrelindgp_foundcorrectly_sel=mat_no_irrelindgp_foundcorrectly; % if both are zero, we cannot compute ratio; to do so, we set both elements to one
    mat_no_irrelindgp_sel=mat_no_irrelindgp;                               
    mat_no_irrelindgp_foundcorrectly_sel(mat_no_irrelindgp_foundcorrectly==0 & mat_no_irrelindgp==0)=1.0;
    mat_no_irrelindgp_sel(mat_no_irrelindgp_foundcorrectly==0 & mat_no_irrelindgp==0)=1.0; 
    flag_ratio='on';
    if strcmp(flag_ratio,'on')
        mat_no_irrelindgp_foundcorrectly_sel=mat_no_irrelindgp_foundcorrectly_sel./mat_no_irrelindgp_sel;
    end
    no_irrelindgp_foundcorrectly_mean=mean(mat_no_irrelindgp_foundcorrectly_sel,3);
    eval(['mat_no_irrelindgp_foundcorrectly_sel_',method_str,'=','mat_no_irrelindgp_foundcorrectly_sel;']);
    eval(['no_irrelindgp_foundcorrectly_mean_',method_str,'=','no_irrelindgp_foundcorrectly_mean;']);
    % output
    disp([method_str,':']);
    disp('pct of correctly identified relevant variables');
    disp(no_relindgp_foundcorrectly_mean);
    disp('pct of correctly identified irrelevant variables');
    disp(no_irrelindgp_foundcorrectly_mean);
    %
    % difference of the number fo correctly identified rel variable
    index_rest = setdiff(1:size(mat_no_relindgp_foundcorrectly_sel,1),index_ref);
    mat_no_relindgp_foundcorrectly_sel_mean = mean(mat_no_relindgp_foundcorrectly_sel,3);
    mat_no_relindgp_foundcorrectly_sel_p = permute(mat_no_relindgp_foundcorrectly_sel,[3 1 2]);
    mat_no_relindgp_foundcorrectly_sel_p2 = reshape(mat_no_relindgp_foundcorrectly_sel_p,size(mat_no_relindgp_foundcorrectly_sel,3),size(mat_no_relindgp_foundcorrectly_sel,1)*size(mat_no_relindgp_foundcorrectly_sel,2));
    figure;newplot;
    for j=1:size(mat_no_relindgp_foundcorrectly_sel_p2,2)
        hpdprctile_flag='hpd';
        if strcmp(hpdprctile_flag,'hpd')
            ki=f_hpd(mat_no_relindgp_foundcorrectly_sel_p2(:,j),1.0-clev);
        else
            alpha=1-clev;ki=prctile(mat_no_relindgp_foundcorrectly_sel_p2(:,j),[(alpha/2)*100,(1-alpha/2)*100]);
        end
        ki_mat(j,:) = ki;
        subplot(2,ceil(size(mat_no_relindgp_foundcorrectly_sel_p2,2)/2),j);dat=mat_no_relindgp_foundcorrectly_sel_p2(:,j);
        if strcmp(flag_ratio,'on')
            hist(dat);
        else
            hist(dat,min(dat):max(dat));
        end
    end
    mat_no_relindgp_foundcorrectly_sel_diff_mat = nan(size(index_rest,2),size(mat_no_relindgp_foundcorrectly_sel,2),size(mat_no_relindgp_foundcorrectly_sel,3));
    ii = 1;
    for index = index_rest
        mat_no_relindgp_foundcorrectly_sel_diff_mat(ii,:,:) = mat_no_relindgp_foundcorrectly_sel(index,:,:)-mat_no_relindgp_foundcorrectly_sel(index_ref,:,:);
        ii = ii+1;
    end
    no_relindgp_foundcorrectly_sel_diff_mean = mean(mat_no_relindgp_foundcorrectly_sel_diff_mat,3);
    no_relindgp_foundcorrectly_sel_diff_meaneqzero = mean(mat_no_relindgp_foundcorrectly_sel_diff_mat==0,3);
    no_relindgp_foundcorrectly_sel_diff_median = median(mat_no_relindgp_foundcorrectly_sel_diff_mat,3);
    mat_no_relindgp_foundcorrectly_sel_diff_mat_p = permute(mat_no_relindgp_foundcorrectly_sel_diff_mat,[3 1 2]);
    mat_no_relindgp_foundcorrectly_sel_diff_mat_p2 = reshape(mat_no_relindgp_foundcorrectly_sel_diff_mat_p,size(mat_no_relindgp_foundcorrectly_sel_diff_mat,3),size(mat_no_relindgp_foundcorrectly_sel_diff_mat,1)*size(mat_no_relindgp_foundcorrectly_sel_diff_mat,2));
    ki_mat = nan(size(mat_no_relindgp_foundcorrectly_sel_diff_mat_p2,2),2);
    figure;newplot;
    for j=1:size(mat_no_relindgp_foundcorrectly_sel_diff_mat_p2,2)
        hpdprctile_flag='hpd';
        if strcmp(hpdprctile_flag,'hpd')
            ki = f_hpd(mat_no_relindgp_foundcorrectly_sel_diff_mat_p2(:,j),1.0-clev);
        else
            alpha=1-clev;
            ki = prctile(mat_no_relindgp_foundcorrectly_sel_diff_mat_p2(:,j),[(alpha/2)*100,(1-alpha/2)*100]);
        end
        ki_mat(j,:) = ki;
        subplot(2,ceil(size(mat_no_relindgp_foundcorrectly_sel_diff_mat_p2,2)/2),j);dat=mat_no_relindgp_foundcorrectly_sel_diff_mat_p2(:,j);
        if strcmp(flag_ratio,'on')
            hist(dat);
        else
            hist(dat,min(dat):max(dat));
        end
    end
    mat_no_relindgp_foundcorrectly_sel_diff_ki = [reshape(no_relindgp_foundcorrectly_sel_diff_mean,size(mat_no_relindgp_foundcorrectly_sel_diff_mat,1)*size(mat_no_relindgp_foundcorrectly_sel_diff_mat,2),1),ki_mat]';
    mat_no_relindgp_foundcorrectly_sel_diff_all = reshape(mat_no_relindgp_foundcorrectly_sel_diff_ki,size(mat_no_relindgp_foundcorrectly_sel_diff_mat,1)*3,size(mat_no_relindgp_foundcorrectly_sel_diff_mat,2));
    eval(['mat_no_relindgp_foundcorrectly_sel_mean_',method_str,'=','mat_no_relindgp_foundcorrectly_sel_mean;']);
    eval(['mat_no_relindgp_foundcorrectly_sel_diff_all_',method_str,'=','mat_no_relindgp_foundcorrectly_sel_diff_all;']);
    %
    % difference of the number fo correctly identified irrel variable
    index_rest = setdiff(1:size(mat_no_irrelindgp_foundcorrectly_sel,1),index_ref);
    mat_no_irrelindgp_foundcorrectly_sel_mean = mean(mat_no_irrelindgp_foundcorrectly_sel,3);
    mat_no_irrelindgp_foundcorrectly_sel_p = permute(mat_no_irrelindgp_foundcorrectly_sel,[3 1 2]);
    mat_no_irrelindgp_foundcorrectly_sel_p2 = reshape(mat_no_irrelindgp_foundcorrectly_sel_p,size(mat_no_irrelindgp_foundcorrectly_sel,3),size(mat_no_irrelindgp_foundcorrectly_sel,1)*size(mat_no_irrelindgp_foundcorrectly_sel,2));
    figure;newplot;
    for j=1:size(mat_no_irrelindgp_foundcorrectly_sel_p2,2)
        hpdprctile_flag='hpd';
        if strcmp(hpdprctile_flag,'hpd')
            ki=f_hpd(mat_no_irrelindgp_foundcorrectly_sel_p2(:,j),1.0-clev);
        else
            alpha=1-clev;ki=prctile(mat_no_irrelindgp_foundcorrectly_sel_p2(:,j),[(alpha/2)*100,(1-alpha/2)*100]);
        end
        ki_mat(j,:) = ki;
        subplot(2,ceil(size(mat_no_irrelindgp_foundcorrectly_sel_p2,2)/2),j);dat=mat_no_irrelindgp_foundcorrectly_sel_p2(:,j);
        if strcmp(flag_ratio,'on')
            hist(dat);
        else
            hist(dat,min(dat):max(dat));
        end
    end
    mat_no_irrelindgp_foundcorrectly_sel_diff_mat = nan(size(index_rest,2),size(mat_no_irrelindgp_foundcorrectly_sel,2),size(mat_no_irrelindgp_foundcorrectly_sel,3));
    ii = 1;
    for index = index_rest
        mat_no_irrelindgp_foundcorrectly_sel_diff_mat(ii,:,:) = mat_no_irrelindgp_foundcorrectly_sel(index,:,:)-mat_no_irrelindgp_foundcorrectly_sel(index_ref,:,:);
        ii = ii+1;
    end
    no_irrelindgp_foundcorrectly_sel_diff_mean = mean(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,3);
    no_irrelindgp_foundcorrectly_sel_diff_meaneqzero = mean(mat_no_irrelindgp_foundcorrectly_sel_diff_mat==0,3);
    no_irrelindgp_foundcorrectly_sel_diff_median = median(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,3);
    mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p = permute(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,[3 1 2]);
    mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p2 = reshape(mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p,size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,3),size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,1)*size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,2));
    ki_mat = nan(size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p2,2),2);
    figure;newplot;
    for j=1:size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p2,2)
        hpdprctile_flag='hpd';
        if strcmp(hpdprctile_flag,'hpd')
            ki = f_hpd(mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p2(:,j),1.0-clev);
        else
            alpha=1-clev;
            ki = prctile(mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p2(:,j),[(alpha/2)*100,(1-alpha/2)*100]);
        end
        ki_mat(j,:) = ki;
        subplot(2,ceil(size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p2,2)/2),j);dat=mat_no_irrelindgp_foundcorrectly_sel_diff_mat_p2(:,j);
        if strcmp(flag_ratio,'on')
            hist(dat);
        else
            hist(dat,min(dat):max(dat));
        end
    end
    mat_no_irrelindgp_foundcorrectly_sel_diff_ki = [reshape(no_irrelindgp_foundcorrectly_sel_diff_mean,size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,1)*size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,2),1),ki_mat]';
    mat_no_irrelindgp_foundcorrectly_sel_diff_all = reshape(mat_no_irrelindgp_foundcorrectly_sel_diff_ki,size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,1)*3,size(mat_no_irrelindgp_foundcorrectly_sel_diff_mat,2));
    eval(['mat_no_irrelindgp_foundcorrectly_sel_mean_',method_str,'=','mat_no_irrelindgp_foundcorrectly_sel_mean;']);
    eval(['mat_no_irrelindgp_foundcorrectly_sel_diff_all_',method_str,'=','mat_no_irrelindgp_foundcorrectly_sel_diff_all;']);
    % 
    % show
    disp(' ');
    disp('diff of no correctly rel var, mean over mc rep');
    disp(no_relindgp_foundcorrectly_sel_diff_mean);
    disp('number of times the diff equals zero, median over mc rep');
    disp(no_relindgp_foundcorrectly_sel_diff_median);
    disp('number of times the diff equals zero, mean over mc rep');
    disp(no_relindgp_foundcorrectly_sel_diff_meaneqzero);
    disp('diff of no correctly rel var, mean over mc rep, 90% hpdi lower bound, upper bound');
    disp(mat_no_relindgp_foundcorrectly_sel_diff_all);
    disp(' ');
    disp('diff of no correctly irrel var, mean over mc rep');
    disp(no_irrelindgp_foundcorrectly_sel_diff_mean);
    disp('diff of no correctly irrel var, median over mc rep');
    disp(no_irrelindgp_foundcorrectly_sel_diff_median);
    disp('number of times the diff equals zero, mean over mc rep');
    disp(no_irrelindgp_foundcorrectly_sel_diff_meaneqzero);
    disp('diff of no correctly irrel var, mean over mc rep, 90% hpdi lower bound, upper bound');
    disp(mat_no_irrelindgp_foundcorrectly_sel_diff_all);
end


%
% table out
%
% cell array
tab_show=cell(1,1);
tab_show(2,3)={'s0='};
tab_show(3,2:4)=cellstr(num2str(s0_dgp_vec','%10.1f'))';
tab_show(4,1)={' '};
% rmse stats   
mat_vec(1).mat=rmse;
rmse_diff_all_out=cell(4,3);
for i=1:2
    for j=1:3
        rmse_diff_all_out{(i-1)*2+1,j}=rmse_diff_all((i-1)*3+1,j);
        rmse_diff_all_out{(i-1)*2+2,j}=[rmse_diff_all((i-1)*3+2,j),rmse_diff_all((i-1)*3+3,j)];
    end
end
mat_vec(2).mat=rmse_diff_all_out;
mat_vec(3).mat=rmse_reltlp;
% labels
prior_str_vec_out={'normal prior';'one-layer prior';'two-layer prior'};
panel2_str_vec={'normal minus two-layer';' ';'one-layer minus two-layer';' '};
panel_str_vec={'Mean over MC replications'; ...
               'RMSE, normalized to one for two-layer prior'; ...
               'Difference of RMSEs between priors (mean, 95\\%% interval)'};
% cell array
tab_show(end+1,1)={'A. RMSE of common components'};
for i=1:length(mat_vec)
    tab_show(end+1,1)=panel_str_vec(i,1);
    nrow=size(mat_vec(i).mat,1);
    ncol=size(mat_vec(i).mat,2);
    if i==2 || i==5 || i==7 || i==9 || i==11
        tab_show(end+1:end+nrow,1)=panel2_str_vec;
    else
        tab_show(end+1:end+nrow,1)=prior_str_vec_out;
    end
    n_digs=3;
    for j=1:nrow
        for k=1:ncol
            if i==2 || i==5 || i==7 || i==9 || i==11
                if round(j/2)==j/2
                    ci=mat_vec(i).mat{j,k};
                    ci_str=['(',num2str(ci(1,1),['%10.',num2str(n_digs),'f']),',',num2str(ci(1,2),['%10.',num2str(n_digs),'f']),')'];
                    tab_show(end-nrow+j,1+k)=cellstr(ci_str);
                else
                    tab_show(end-nrow+j,1+k)=cellstr(num2str(mat_vec(i).mat{j,k},['%10.',num2str(n_digs),'f']));
                end
            else
                tab_show(end-nrow+j,1+k)=cellstr(num2str(mat_vec(i).mat(j,k),['%10.',num2str(n_digs),'f']));
            end
        end
    end
    tab_show(end+1,1)=cellstr(' ');
end
% rel/irrel stats   
mat_vec(1,1).mat=no_relindgp_foundcorrectly_mean_lamhpd;
nofound_diff_all_out=cell(4,3);
nofound=mat_no_relindgp_foundcorrectly_sel_diff_all_lamhpd;
for i=1:2
    for j=1:3
        nofound_diff_all_out{(i-1)*2+1,j}=nofound((i-1)*3+1,j);
        nofound_diff_all_out{(i-1)*2+2,j}=[nofound((i-1)*3+2,j),nofound((i-1)*3+3,j)];
    end
end
mat_vec(1,2).mat=nofound_diff_all_out;
mat_vec(2,1).mat=no_irrelindgp_foundcorrectly_mean_lamhpd;
nofound_diff_all_out=cell(4,3);
nofound=mat_no_irrelindgp_foundcorrectly_sel_diff_all_lamhpd;
for i=1:2
    for j=1:3
        nofound_diff_all_out{(i-1)*2+1,j}=nofound((i-1)*3+1,j);
        nofound_diff_all_out{(i-1)*2+2,j}=[nofound((i-1)*3+2,j),nofound((i-1)*3+3,j)];
    end
end
mat_vec(2,2).mat=nofound_diff_all_out;
mat_vec(3,1).mat=no_relindgp_foundcorrectly_mean_mhpdmah;
nofound_diff_all_out=cell(4,3);
nofound=mat_no_relindgp_foundcorrectly_sel_diff_all_mhpdmah;
for i=1:2
    for j=1:3
        nofound_diff_all_out{(i-1)*2+1,j}=nofound((i-1)*3+1,j);
        nofound_diff_all_out{(i-1)*2+2,j}=[nofound((i-1)*3+2,j),nofound((i-1)*3+3,j)];
    end
end
mat_vec(3,2).mat=nofound_diff_all_out;
mat_vec(4,1).mat=no_irrelindgp_foundcorrectly_mean_mhpdmah;
nofound_diff_all_out=cell(4,3);
nofound=mat_no_irrelindgp_foundcorrectly_sel_diff_all_mhpdmah;
for i=1:2
    for j=1:3
        nofound_diff_all_out{(i-1)*2+1,j}=nofound((i-1)*3+1,j);
        nofound_diff_all_out{(i-1)*2+2,j}=[nofound((i-1)*3+2,j),nofound((i-1)*3+3,j)];
    end
end
mat_vec(4,2).mat=nofound_diff_all_out;
% labels
prior_str_vec_out={'normal prior';'one-layer prior';'two-layer prior'};
panel2_str_vec={'normal minus two-layer';' ';'one-layer minus two-layer';' '};
panel_str_vec={'B. Univariate loadings HPD: Relevant variables','Ratio of correctly identified relevant variables','Differences between priors (mean, 95\\%% interval)'; ...
    'C. Univariate loadings HPD: Irrelevant variables','Ratio of correctly identified irrelevant variables','Differences between priors (mean, 95\\%% interval)'; ...
    'D. Multivariate loadings HPD: Relevant variables','Ratio of correctly identified relevant variables','Differences between priors (mean, 95\\%% interval)'; ...
    'E. Multivariate loadings HPD: Irrelevant variables','Ratio of correctly identified irrelevant variables','Differences between priors (mean, 95\\%% interval)'};
% cell array to latex
for i=1:length(mat_vec)
    tab_show(end+1,1)=panel_str_vec(i,1);
    for jj=1:2
        tab_show(end+1,1)=panel_str_vec(i,1+jj);
        nrow=size(mat_vec(i,jj).mat,1);
        ncol=size(mat_vec(i,jj).mat,2);
        if jj==2
            tab_show(end+1:end+nrow,1)=panel2_str_vec;
        else
            tab_show(end+1:end+nrow,1)=prior_str_vec_out;
        end
        n_digs=2;
        for j=1:nrow
            for k=1:ncol
                if jj==2
                    if round(j/2)==j/2
                        ci=mat_vec(i,jj).mat{j,k};
                        ci_str=['(',num2str(ci(1,1),['%10.',num2str(n_digs),'f']),',',num2str(ci(1,2),['%10.',num2str(n_digs),'f']),')'];
                        tab_show(end-nrow+j,1+k)=cellstr(ci_str);
                    else
                        tab_show(end-nrow+j,1+k)=cellstr(num2str(mat_vec(i,jj).mat{j,k},['%10.',num2str(n_digs),'f']));
                    end
                else
                    tab_show(end-nrow+j,1+k)=cellstr(num2str(mat_vec(i,jj).mat(j,k),['%10.',num2str(n_digs),'f']));
                end
            end
        end
        tab_show(end+1,1)=cellstr(' ');
    end
end
tab_show
tablename='simulation results: rmse for common components and identification of relevant and irrelevant variables';
savename=[folder_save,'results_sims.tex'];
f_cell2latex(tab_show,savename,tablename);

end

%     % compute ratio from sums over reps first
%     ratio2_no_relindgp_foundcorrectly=sum(mat_no_relindgp_foundcorrectly,3)./sum(mat_no_relindgp,3);
%     ratio2_no_irrelindgp_foundcorrectly=sum(mat_no_irrelindgp_foundcorrectly,3)./sum(mat_no_irrelindgp,3);
%     disp('ratio2');
%     disp('pct of correctly identified relevant variables');
%     disp(ratio2_no_relindgp_foundcorrectly);
%     disp('pct of correctly identified irrelevant variables');
%     disp(ratio2_no_irrelindgp_foundcorrectly);
%     % [mat_no_irrelindgp_foundcorrectly,mat_no_irrelindgp], [sum(mat_no_irrelindgp_foundcorrectly,3),sum(mat_no_irrelindgp,3)]
%     eval(['ratio2_no_relindgp_foundcorrectly_',method_str,'=','ratio2_no_relindgp_foundcorrectly',';']);
%     eval(['ratio2_no_irrelindgp_foundcorrectly_',method_str,'=','ratio2_no_irrelindgp_foundcorrectly',';']);
