clear all
close all
rng default 

prepare_pathsdgpsmodels

% generate folder and for results
folder_save='.\data\';
if not(exist(folder_save,'dir')==7)
    mkdir(folder);
end

for s0_index=1:length(s0_dgp_vec)
    %
    % specify prior for rho
    rho0_sim=kron(ones(nf_sim,1),[30,s0_dgp_vec(s0_index)]); %rho0_1=precision, rho0_2=mean
    disp(' ');
    disp(['s0 ',num2str(s0_dgp_vec(s0_index))]);
    disp(' ');
    for rep=1:n_rep
        disp([' rep ',num2str(rep),' from ',num2str(n_rep)]);
        % 
        % sim data based on s0
        dgp_spec=struct('N_sim',N_sim,'T_sim',T_sim,'T0_sim',T0_sim,'nf_sim',nf_sim, ...
            'philag_sim',philag_sim,'psilag_sim',psilag_sim,'rho0_sim',rho0_sim);
        results=f_simdatsparse(dgp_spec);
        xt=results.xt;
        ftstar_true=results.ftstar_true;
        lamspar_true=results.lamspar_true;
        lamspar_index_true=results.lamspar_index_true;
        Mout=results.Mout;
        m0out=results.m0out;
        clear results
        %
        % define top two variables to be founding, allow for correct
        % identification by utz for normal prior
        flag_founderstopdgp='off';
        results.spec.flag_founderstopdgp=flag_founderstopdgp;
        if strcmp(flag_founderstopdgp,'on')
            lamspar_true(1,2)=0.0;lamspar_index_true(1,2)=0.0;
            x_cc_top=zeros(size(xt,1),2);
            lamstar=m0out(1)+sqrt(Mout).*randn(1,1);
            lamspar_true(1,1)=lamstar;lamspar_index_true(1,1)=1.0;
            x_cc_top(:,1)=x_cc_top(:,1)+ftstar_true(:,1)*lamstar;
            lamstar=m0out(2)+sqrt(Mout).*randn(1,1);
            lamspar_true(2,2)=lamstar;lamspar_index_true(2,2)=1.0;
            x_cc_top(:,2)=x_cc_top(:,2)+ftstar_true(:,2)*lamstar;
            sigeps0=mean(1-m0out(1:nf_sim).^2);
            x_irr_top=sqrt(sigeps0).*randn(size(xt,1),2);
            xt_top=x_cc_top+x_irr_top;
            xt(:,1:2)=xt_top;
        end
        % 
        % sim irrelevant variables at 51:60
        N_irr=10;
        sigeps0=mean(1-m0out(1:nf_sim).^2);
        flag_pers_xirr = 'wn';
        if strcmp(flag_pers_xirr,'wn');
            x_irr = sqrt(sigeps0).*randn(size(xt,1),N_irr);
        elseif strcmp(flag_pers_xirr,'pers');
            betaar=0.5;
            sigeps2=sigeps0*(1.0-betaar^2);
            x_irr=sqrt(sigeps2).*randn(size(xt,1),N_irr);
            for t=2:size(xt,1)
                for i=1:N_irr
                    x_irr(t,i)=betaar*x_irr(t-1,i)+x_irr(t,i);
                end
            end
        end
        xt(:,41:50)=x_irr;
        lamspar_index_true(41:50,:)=zeros(N_irr,2);
        %
        % sim relevant variables at 41:50
        N_rel=10;
        x_cc=zeros(size(xt,1),N_rel);
        lamspar_index_true_rel=zeros(N_rel,2);
        for i=1:N_rel
            u=rand(1);
            if (u<0.5)
                lamstar=m0out(1)+sqrt(Mout).*randn(1,1);
                x_cc(:,i)=x_cc(:,i)+ftstar_true(:,1)*lamstar;
                lamspar_index_true_rel(i,1)=1.0;
            else
                lamstar=m0out(2)+sqrt(Mout).*randn(1,1);
                x_cc(:,i)=x_cc(:,i)+ftstar_true(:,2)*lamstar;
                lamspar_index_true_rel(i,2)=1.0;
            end
        end
        flag_pers_xirr = 'wn';
        sigeps0=mean(1-m0out(1:nf_sim).^2);
        if strcmp(flag_pers_xirr,'wn');
            x_idio = sqrt(sigeps0).*randn(size(xt,1),N_rel);
        elseif strcmp(flag_pers_xirr,'pers');
            betaar=0.5;
            sigeps2=sigeps0*(1.0-betaar^2);
            x_idio=sqrt(sigeps2).*randn(size(xt,1),N_rel);
            for t=2:size(xt,1)
                for i=1:N_rel
                    x_idio(t,i)=betaar*x_idio(t-1,i)+x_idio(t,i);
                end
            end
        end
        xt(:,51:60)=x_cc+x_idio;
        lamspar_index_true(51:60,:)=lamspar_index_true_rel;
        %
        % store output
        datasim.xt=xt;
        datasim.ftstar_true=ftstar_true;
        datasim.lamspar_true=lamspar_true;
        datasim.lamspar_index_true=lamspar_index_true;
        save_str=['datasim_s',num2str(s0_dgp_vec(s0_index)*100,'%03.0f'),'_rep',num2str(rep)];
        savename=[folder_save,save_str]';
        save(savename,'datasim');
        clear datasim
        % 
        % some stats about simulated data
        index_true_sel=41:60; N_irrrel=length(index_true_sel);
        lamspar_index_true_sel=lamspar_index_true(index_true_sel,:); % select those columns to be evaluated
        variable_relevant_true_index=sum(lamspar_index_true_sel,2)>=1;
        no_variable_relevant_true=sum(variable_relevant_true_index,1);
        variable_irrelevant_true_index=sum(lamspar_index_true_sel,2)==0;
        no_variable_irrelevant_true=sum(variable_irrelevant_true_index,1);
        disp(['  dgp sample: no relevant variables ',num2str(no_variable_relevant_true),', no irrelevant variables ',num2str(no_variable_irrelevant_true)]);
        n_overlap=sum(sum(lamspar_index_true,2)==2,1);
        disp(['  relevant variables in each factor: ',num2str(sum(lamspar_index_true,1)),', overlaps: ',num2str(n_overlap)]);
    end    
end
            