function results=f_estimate_sparfac(data,modparam)

% storage sampler results
results = [];

% get model specification
disp(' ');
disp('model specification');
disp(modparam);
param_str_vec={'it','it0','rth','nf','s0','prior','philag','psilag',...
               'utz','f_ind','bf','const','m_adj','s_adj','normp'};
for i=1:size(param_str_vec,2)
    param_str=param_str_vec{1,i};
    eval([param_str,'=','modparam.',param_str,';']);
end
results.modparam=modparam;

% prepare data
y_raw=data.data_fin;
y=f_standardise(y_raw);
nobs=size(y,1);
nvars=size(y,2);

[tau0,beta0,rho0,p0,P0inf,q0,Q0inf,sigeps0,sigetanu0,sigetaS0,er0]=f_specify_prior(data,modparam);
              % out: tau0 (nfx2), beta0=(a0,b0) (nfx2, if prior==2) rho0=(r0,s0) (nfx2, if prior>0), 
              % p0 (nf^2*philagx1), P0inf ((nf^2*philag)x(nf^2*philag)),
              % q0 (nvarsxpsilag) Q0inf(psilagxpsilagxnvars),
              % sigetanu0= e0, sigetaS0=E0 (nfxnf)
              % sigeps0=(u0,U0) (nvarsx2)
obj_str_vec={'tau0','beta0','rho0','p0','P0inf','q0','Q0inf','sigeps0', ...
               'sigetanu0','sigetaS0','er0'};
for i=1:size(obj_str_vec,2)
    obj_str=obj_str_vec{1,i};
    eval(['param_init.',obj_str,'=',obj_str,';']);
end

[lam,lamspar,phi,phistar,psim,sigeta,sigeps,betam,rho,tau,ft,ftstar]=f_initialize_values(data,modparam,param_init);
                  % out: lam (nvarsxnf), lamstar(?), phistar(nfxnf*philag), psim(nvarsxpsilag), sigeta (nfxnf)
                  % sigeps (nvarsx1), betam (nvarsxnf), rho (nfx1), tau (nfx1)
                  % uses j, m as running variables
clear modparam param_init

% call gibbs
tstart=tic;
[deltamc,acc,ftmc,ftmcstar,nvarsmc,lammc,lamstarmc,phimc,phistarmc,psimc,sigetamc,sigetastarmc,er0mc,sigepsmc,taumc,betamc,rhomc] = ...
    f_mcmc_sparfac(y,lam,phi,phistar,psim,sigeta,sigeps,tau,betam,rho,f_ind,p0,P0inf,q0,Q0inf,sigetanu0,sigetaS0,er0,sigeps0,tau0,beta0,rho0, ...
    nvars,nobs,nf,psilag,philag,it,it0,rth,bf,prior,normp,utz,ftstar,lamspar,ft);
elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed estimation time ',num2str(elt),' hours']);

% loadings and factors
results.lamstarmc = lamstarmc;
results.fstarmc = ftmcstar;

% names and group names
results.name_ser = data.name_ser;
results.name_ser_group = data.name_ser_group;
results.data_raw = y_raw;
results.data = y;

end

